package teralg;

/**
 * Sor adatszerkezet
 * @author Máté Cserép <mcserep@outlook.com>
 */
public class MyQueue<T> {
    // Láncolt listás reprezentáció
    private class Node {
        public T data;
        public Node next;
        
        public Node(T data, Node next) {
            this.data = data;
            this.next = next;
        }
    }
    
    private Node head; // első elem
    private Node tail; // utolsó elem
    
    // Új, üres sor létrehozása
    public MyQueue() {
        head = null;
        tail = null;
    }
    
    // Sorba
    public void push(T value) {
        Node node = new Node(value, null);
        if(empty())
            head = node;
        else
            tail.next = node;
        tail = node;
    }
    
    // Első
    public T first() {
        if(head == null)
            throw new IllegalStateException("The queue is empty.");
        return head.data;
    }
    
    // Sorból
    public T pop() {
        if(head == null)
            throw new IllegalStateException("The queue is empty.");
        
        T result = head.data;
        head = head.next;
        return result;
    }
    
    // Üres-e
    public boolean empty() {
        return head == null;
    }
}
